diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/bindings/modulegen__gcc_LP64.py ns-3.36/src/core/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/core/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:57.790733000 -0700
@@ -3632,27 +3637,27 @@
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['bool'], visibility='protected')
+                   is_static=True, template_parameters=['void'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['std::__cxx11::basic_string<char', ' std::char_traits<char>', ' std::allocator<char> > '], visibility='protected')
+                   is_static=True, template_parameters=['unsigned char*'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['void'], visibility='protected')
+                   is_static=True, template_parameters=['long'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['unsigned char*'], visibility='protected')
+                   is_static=True, template_parameters=['bool'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['long'], visibility='protected')
+                   is_static=True, template_parameters=['std::__cxx11::basic_string<char', ' std::char_traits<char>', ' std::allocator<char> > '], visibility='protected')
     return
 
 def register_Ns3CallbackValue_methods(root_module, cls):
@@ -5021,6 +5026,18 @@
                    [param('ns3::Time const &', 'value')])
     return
 
+def register_Ns3TupleChecker_methods(root_module, cls):
+    ## tuple.h (module 'core'): ns3::TupleChecker::TupleChecker() [constructor]
+    cls.add_constructor([])
+    ## tuple.h (module 'core'): ns3::TupleChecker::TupleChecker(ns3::TupleChecker const & arg0) [constructor]
+    cls.add_constructor([param('ns3::TupleChecker const &', 'arg0')])
+    ## tuple.h (module 'core'): std::vector<ns3::Ptr<const ns3::AttributeChecker>, std::allocator<ns3::Ptr<const ns3::AttributeChecker>>> const & ns3::TupleChecker::GetCheckers() const [member function]
+    cls.add_method('GetCheckers', 
+                   'std::vector< ns3::Ptr< ns3::AttributeChecker const > > const &', 
+                   [], 
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
+    return
+
 def register_Ns3TypeIdChecker_methods(root_module, cls):
     ## type-id.h (module 'core'): ns3::TypeIdChecker::TypeIdChecker() [constructor]
     cls.add_constructor([])
@@ -5189,10 +5206,10 @@
                    'std::string', 
                    [], 
                    is_const=True, is_virtual=True)
-    ## callback.h (module 'core'): bool ns3::CallbackImpl<bool, std::basic_string<char>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(std::basic_string<char, std::char_traits<char>, std::allocator<char> > arg0) [member operator]
+    ## callback.h (module 'core'): bool ns3::CallbackImpl<bool, std::basic_string<char>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(std::basic_string<char, std::char_traits<char>, std::allocator<char>> arg0) [member operator]
     cls.add_method('operator()', 
                    'bool', 
-                   [param('std::string', 'arg0')], 
+                   [param('std::basic_string< char, std::char_traits< char >, std::allocator< char > >', 'arg0')], 
                    custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
@@ -5267,7 +5284,7 @@
     cls.add_constructor([param('ns3::Config::MatchContainer const &', 'arg0')])
     ## config.h (module 'core'): ns3::Config::MatchContainer::MatchContainer() [constructor]
     cls.add_constructor([])
-    ## config.h (module 'core'): ns3::Config::MatchContainer::MatchContainer(std::vector<ns3::Ptr<ns3::Object>, std::allocator<ns3::Ptr<ns3::Object> > > const & objects, std::vector<std::basic_string<char>, std::allocator<std::basic_string<char> > > const & contexts, std::string path) [constructor]
+    ## config.h (module 'core'): ns3::Config::MatchContainer::MatchContainer(std::vector<ns3::Ptr<ns3::Object>, std::allocator<ns3::Ptr<ns3::Object>>> const & objects, std::vector<std::basic_string<char>, std::allocator<std::basic_string<char>>> const & contexts, std::string path) [constructor]
     cls.add_constructor([param('std::vector< ns3::Ptr< ns3::Object > > const &', 'objects'), param('std::vector< std::string > const &', 'contexts'), param('std::string', 'path')])
     ## config.h (module 'core'): ns3::Config::MatchContainer::Iterator ns3::Config::MatchContainer::Begin() const [member function]
     cls.add_method('Begin', 
@@ -5331,6 +5348,21 @@
     cls.add_method('SetFailSafe', 
                    'bool', 
                    [param('std::string', 'name'), param('ns3::AttributeValue const &', 'value')])
+    ## config.h (module 'core'): ns3::Config::MatchContainer::Iterator ns3::Config::MatchContainer::begin() const [member function]
+    cls.add_method('begin', 
+                   'ns3::Config::MatchContainer::Iterator', 
+                   [], 
+                   is_const=True)
+    ## config.h (module 'core'): ns3::Config::MatchContainer::Iterator ns3::Config::MatchContainer::end() const [member function]
+    cls.add_method('end', 
+                   'ns3::Config::MatchContainer::Iterator', 
+                   [], 
+                   is_const=True)
+    ## config.h (module 'core'): std::size_t ns3::Config::MatchContainer::size() const [member function]
+    cls.add_method('size', 
+                   'std::size_t', 
+                   [], 
+                   is_const=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -5521,6 +5553,11 @@
                         'ns3::Ptr< ns3::PairChecker const >', 
                         [param('ns3::Ptr< ns3::AttributeChecker const > const &', 'p')], 
                         template_parameters=['ns3::PairChecker const', ' ns3::AttributeChecker const'])
+    ## ptr.h (module 'core'): ns3::Ptr<const ns3::TupleChecker> ns3::DynamicCast(ns3::Ptr<const ns3::AttributeChecker> const & p) [free function]
+    module.add_function('DynamicCast', 
+                        'ns3::Ptr< ns3::TupleChecker const >', 
+                        [param('ns3::Ptr< ns3::AttributeChecker const > const &', 'p')], 
+                        template_parameters=['ns3::TupleChecker const', ' ns3::AttributeChecker const'])
     ## length.h (module 'core'): ns3::Length ns3::Feet(double value) [free function]
     module.add_function('Feet', 
                         'ns3::Length', 
@@ -5541,6 +5578,10 @@
     module.add_function('GetLogComponent', 
                         'ns3::LogComponent &', 
                         [param('std::string const', 'name')])
+    ## hash.h (module 'core'): ns3::Hasher & ns3::GetStaticHash() [free function]
+    module.add_function('GetStaticHash', 
+                        'ns3::Hasher &', 
+                        [])
     ## hash.h (module 'core'): uint32_t ns3::Hash32(std::string const s) [free function]
     module.add_function('Hash32', 
                         'uint32_t', 
@@ -5998,7 +6039,7 @@
     module.add_function('FindSelfDirectory', 
                         'std::string', 
                         [])
-    ## system-path.h (module 'core'): std::string ns3::SystemPath::Join(std::list<std::basic_string<char>, std::allocator<std::basic_string<char> > >::const_iterator begin, std::list<std::basic_string<char>, std::allocator<std::basic_string<char> > >::const_iterator end) [free function]
+    ## system-path.h (module 'core'): std::string ns3::SystemPath::Join(std::list<std::basic_string<char>, std::allocator<std::basic_string<char>>>::const_iterator begin, std::list<std::basic_string<char>, std::allocator<std::basic_string<char>>>::const_iterator end) [free function]
     module.add_function('Join', 
                         'std::string', 
                         [param('std::list< std::string > const_iterator', 'begin'), param('std::list< std::string > const_iterator', 'end')])
@@ -6010,11 +6051,11 @@
     module.add_function('MakeTemporaryDirectoryName', 
                         'std::string', 
                         [])
-    ## system-path.h (module 'core'): std::list<std::basic_string<char>, std::allocator<std::basic_string<char> > > ns3::SystemPath::ReadFiles(std::string path) [free function]
+    ## system-path.h (module 'core'): std::list<std::basic_string<char>, std::allocator<std::basic_string<char>>> ns3::SystemPath::ReadFiles(std::string path) [free function]
     module.add_function('ReadFiles', 
                         'std::list< std::string >', 
                         [param('std::string', 'path')])
-    ## system-path.h (module 'core'): std::list<std::basic_string<char>, std::allocator<std::basic_string<char> > > ns3::SystemPath::Split(std::string path) [free function]
+    ## system-path.h (module 'core'): std::list<std::basic_string<char>, std::allocator<std::basic_string<char>>> ns3::SystemPath::Split(std::string path) [free function]
     module.add_function('Split', 
                         'std::list< std::string >', 
                         [param('std::string', 'path')])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/CMakeLists.txt ns-3.36/src/core/CMakeLists.txt
--- ns-3.35/src/core/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/core/CMakeLists.txt	2022-04-30 18:23:57.790733000 -0700
@@ -0,0 +1,383 @@
+# Set lib core link dependencies
+set(libraries_to_link)
+
+set(gsl_test_sources)
+if(${GSL_FOUND})
+  include_directories(${GSL_INCLUDE_DIRS})
+  set(libraries_to_link
+      ${libraries_to_link}
+      ${GSL_LIBRARIES}
+  )
+  set(gsl_test_sources
+      test/rng-test-suite.cc
+      test/random-variable-stream-test-suite.cc
+  )
+endif()
+
+# Check for dependencies and add sources accordingly
+if(${CMAKE_VERSION}
+   VERSION_LESS
+   "3.11.0"
+)
+  check_include_file_cxx(
+    boost/units/quantity.hpp
+    HAVE_BOOST_UNITS_QUANTITY
+  )
+  check_include_file_cxx(
+    boost/units/systems/si.hpp
+    HAVE_BOOST_UNITS_SI
+  )
+  if(${HAVE_BOOST_UNITS_QUANTITY}
+     AND ${HAVE_BOOST_UNITS_SI}
+  )
+    set(HAVE_BOOST_UNITS
+        TRUE
+    )
+  else()
+    set(HAVE_BOOST_UNITS
+        FALSE
+    )
+  endif()
+else()
+  # Fast path for CMake >= 3.11
+  check_include_files(
+    "boost/units/quantity.hpp;boost/units/systems/si.hpp"
+    HAVE_BOOST_UNITS
+    LANGUAGE
+    CXX
+  )
+endif()
+
+if(${HAVE_BOOST_UNITS})
+  add_definitions(
+    -DHAVE_BOOST
+    -DHAVE_BOOST_UNITS
+  )
+  message(STATUS "Boost Units have been found.")
+else()
+  message(
+    STATUS
+      "Boost Units are an optional feature of length.cc."
+      " Ubuntu ships it within the libboost-dev package."
+      " You may need to clean up the CMake cache after installing it to pass this check."
+  )
+endif()
+
+set(rt_sources)
+set(rt_headers)
+if(${ENABLE_REALTIME})
+  set(rt_sources
+      model/realtime-simulator-impl.cc
+      model/wall-clock-synchronizer.cc
+  )
+  set(rt_headers
+      model/realtime-simulator-impl.h
+      model/wall-clock-synchronizer.h
+  )
+  set(libraries_to_link
+      ${libraries_to_link}
+      ${LIBRT}
+  )
+endif()
+
+set(osclock_sources)
+set(osclock_sources
+    model/unix-system-wall-clock-ms.cc
+)
+
+set(int64x64_sources)
+set(int64x64_headers)
+
+if(${NS3_INT64X64}
+   MATCHES
+   "INT128"
+)
+  set(int64x64_sources
+      model/int64x64-128.cc
+  )
+  set(int64x64_headers
+      model/int64x64-128.h
+  )
+elseif(
+  ${NS3_INT64X64}
+  MATCHES
+  "DOUBLE"
+)
+  set(int64x64_headers
+      model/int64x64-double.h
+  )
+elseif(
+  ${NS3_INT64X64}
+  MATCHES
+  "CAIRO"
+)
+  set(int64x64_sources
+      model/int64x64-cairo.cc
+  )
+  set(int64x64_headers
+      model/int64x64-cairo.h
+      model/cairo-wideint-private.h
+  )
+endif()
+
+set(thread_sources
+    model/system-thread.cc
+    model/unix-fd-reader.cc
+    model/unix-system-condition.cc
+    model/unix-system-mutex.cc
+)
+set(thread_headers
+    model/system-condition.h
+    model/system-mutex.h
+    model/system-thread.h
+    model/unix-fd-reader.h
+)
+set(libraries_to_link
+    ${libraries_to_link}
+    pthread
+)
+set(thread_test_sources
+    test/threaded-test-suite.cc
+)
+
+if(${ENABLE_EXAMPLES})
+  set(example_as_test_sources
+      model/example-as-test.cc
+  )
+  set(example_as_test_headers
+      model/example-as-test.h
+  )
+  set(example_as_test_suite
+      test/examples-as-tests-test-suite.cc
+  )
+endif()
+
+# Embedded version support
+set(embedded_version_sources)
+set(embedded_version_headers)
+if(${ENABLE_BUILD_VERSION})
+  set(embedded_version_sources
+      model/version.cc
+  )
+  set(embedded_version_headers
+      model/version.h
+  )
+endif()
+
+# Define core lib sources
+set(source_files
+    ${rt_sources}
+    ${osclock_sources}
+    ${int64x64_sources}
+    ${thread_sources}
+    ${example_as_test_sources}
+    ${embedded_version_sources}
+    helper/csv-reader.cc
+    helper/random-variable-stream-helper.cc
+    helper/event-garbage-collector.cc
+    model/time.cc
+    model/event-id.cc
+    model/scheduler.cc
+    model/list-scheduler.cc
+    model/map-scheduler.cc
+    model/heap-scheduler.cc
+    model/calendar-scheduler.cc
+    model/priority-queue-scheduler.cc
+    model/event-impl.cc
+    model/simulator.cc
+    model/simulator-impl.cc
+    model/default-simulator-impl.cc
+    model/timer.cc
+    model/watchdog.cc
+    model/synchronizer.cc
+    model/make-event.cc
+    model/log.cc
+    model/breakpoint.cc
+    model/type-id.cc
+    model/attribute-construction-list.cc
+    model/object-base.cc
+    model/ref-count-base.cc
+    model/object.cc
+    model/test.cc
+    model/random-variable-stream.cc
+    model/rng-seed-manager.cc
+    model/rng-stream.cc
+    model/command-line.cc
+    model/attribute.cc
+    model/boolean.cc
+    model/integer.cc
+    model/uinteger.cc
+    model/enum.cc
+    model/double.cc
+    model/int64x64.cc
+    model/string.cc
+    model/pointer.cc
+    model/object-ptr-container.cc
+    model/object-factory.cc
+    model/global-value.cc
+    model/trace-source-accessor.cc
+    model/config.cc
+    model/callback.cc
+    model/names.cc
+    model/vector.cc
+    model/fatal-impl.cc
+    model/system-path.cc
+    model/hash-function.cc
+    model/hash-murmur3.cc
+    model/hash-fnv.cc
+    model/hash.cc
+    model/des-metrics.cc
+    model/ascii-file.cc
+    model/node-printer.cc
+    model/show-progress.cc
+    model/time-printer.cc
+    model/system-wall-clock-timestamp.cc
+    model/length.cc
+    model/trickle-timer.cc
+)
+
+# Define core lib headers
+set(header_files
+    ${rt_headers}
+    ${int64x64_headers}
+    ${thread_headers}
+    ${example_as_test_headers}
+    ${embedded_version_headers}
+    helper/csv-reader.h
+    helper/event-garbage-collector.h
+    helper/random-variable-stream-helper.h
+    model/abort.h
+    model/ascii-file.h
+    model/ascii-test.h
+    model/assert.h
+    model/attribute-accessor-helper.h
+    model/attribute-construction-list.h
+    model/attribute-container-accessor-helper.h
+    model/attribute-container.h
+    model/attribute-helper.h
+    model/attribute.h
+    model/boolean.h
+    model/breakpoint.h
+    model/build-profile.h
+    model/calendar-scheduler.h
+    model/callback.h
+    model/command-line.h
+    model/config.h
+    model/default-deleter.h
+    model/default-simulator-impl.h
+    model/deprecated.h
+    model/des-metrics.h
+    model/double.h
+    model/empty.h
+    model/enum.h
+    model/event-id.h
+    model/event-impl.h
+    model/fatal-error.h
+    model/fatal-impl.h
+    model/global-value.h
+    model/hash-fnv.h
+    model/hash-function.h
+    model/hash-murmur3.h
+    model/hash.h
+    model/heap-scheduler.h
+    model/int-to-type.h
+    model/int64x64-double.h
+    model/int64x64.h
+    model/integer.h
+    model/length.h
+    model/list-scheduler.h
+    model/log-macros-disabled.h
+    model/log-macros-enabled.h
+    model/log.h
+    model/make-event.h
+    model/map-scheduler.h
+    model/math.h
+    model/names.h
+    model/node-printer.h
+    model/nstime.h
+    model/object-base.h
+    model/object-factory.h
+    model/object-map.h
+    model/object-ptr-container.h
+    model/object-vector.h
+    model/object.h
+    model/pair.h
+    model/pointer.h
+    model/priority-queue-scheduler.h
+    model/ptr.h
+    model/random-variable-stream.h
+    model/ref-count-base.h
+    model/rng-seed-manager.h
+    model/rng-stream.h
+    model/scheduler.h
+    model/show-progress.h
+    model/simple-ref-count.h
+    model/simulation-singleton.h
+    model/simulator-impl.h
+    model/simulator.h
+    model/singleton.h
+    model/string.h
+    model/synchronizer.h
+    model/system-path.h
+    model/system-wall-clock-ms.h
+    model/system-wall-clock-timestamp.h
+    model/test.h
+    model/time-printer.h
+    model/timer-impl.h
+    model/timer.h
+    model/trace-source-accessor.h
+    model/traced-callback.h
+    model/traced-value.h
+    model/trickle-timer.h
+    model/tuple.h
+    model/type-id.h
+    model/type-name.h
+    model/type-traits.h
+    model/uinteger.h
+    model/unused.h
+    model/valgrind.h
+    model/vector.h
+    model/watchdog.h
+)
+
+set(test_sources
+    ${example_as_test_suite}
+    ${gsl_test_sources}
+    ${thread_test_sources}
+    test/attribute-container-test-suite.cc
+    test/attribute-test-suite.cc
+    test/build-profile-test-suite.cc
+    test/callback-test-suite.cc
+    test/command-line-test-suite.cc
+    test/config-test-suite.cc
+    test/event-garbage-collector-test-suite.cc
+    test/global-value-test-suite.cc
+    test/hash-test-suite.cc
+    test/int64x64-test-suite.cc
+    test/length-test-suite.cc
+    test/many-uniform-random-variables-one-get-value-call-test-suite.cc
+    test/names-test-suite.cc
+    test/object-test-suite.cc
+    test/one-uniform-random-variable-many-get-value-calls-test-suite.cc
+    test/pair-value-test-suite.cc
+    test/ptr-test-suite.cc
+    test/sample-test-suite.cc
+    test/simulator-test-suite.cc
+    test/time-test-suite.cc
+    test/timer-test-suite.cc
+    test/traced-callback-test-suite.cc
+    test/trickle-timer-test-suite.cc
+    test/tuple-value-test-suite.cc
+    test/type-id-test-suite.cc
+    test/type-traits-test-suite.cc
+    test/watchdog-test-suite.cc
+)
+
+# Build core lib
+build_lib(
+  LIBNAME core
+  SOURCE_FILES ${source_files}
+  HEADER_FILES ${header_files}
+  LIBRARIES_TO_LINK ${libraries_to_link}
+  TEST_SOURCES ${test_sources}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/doc/deprecated-example.h ns-3.36/src/core/doc/deprecated-example.h
--- ns-3.35/src/core/doc/deprecated-example.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/doc/deprecated-example.h	2022-04-30 18:23:57.790733000 -0700
@@ -30,10 +30,10 @@
  * \deprecated This method will go away in future versions of ns-3.
  * See instead TheNewWay()
  */
-NS_DEPRECATED_3_XX
-void SomethingUseful (void);
+NS_DEPRECATED_3_XX ("see TheNewWay")
+void SomethingUseful ();
 /*
  * Do something more useful.
  */
-void TheNewWay (void);
+void TheNewWay ();
 // [doxygen snippet]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/CMakeLists.txt ns-3.36/src/core/examples/CMakeLists.txt
--- ns-3.35/src/core/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/core/examples/CMakeLists.txt	2022-04-30 18:23:57.790733000 -0700
@@ -0,0 +1,58 @@
+set(base_examples
+    command-line-example
+    fatal-example
+    hash-example
+    length-example
+    main-callback
+    main-ptr
+    sample-log-time-format
+    sample-random-variable
+    sample-random-variable-stream
+    sample-show-progress
+    sample-simulator
+    system-path-examples
+    test-string-value-formatting
+)
+
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+    LIBRARIES_TO_LINK ${libcore}
+  )
+endforeach()
+
+build_lib_example(
+  NAME main-random-variable-stream
+  SOURCE_FILES main-random-variable-stream.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libconfig-store}
+    ${libstats}
+)
+
+if(${ENABLE_BUILD_VERSION})
+  build_lib_example(
+    NAME build-version-example
+    SOURCE_FILES build-version-example.cc
+    LIBRARIES_TO_LINK ${libcore}
+  )
+endif()
+
+if(${ENABLE_REALTIME})
+  build_lib_example(
+    NAME main-test-sync
+    SOURCE_FILES main-test-sync.cc
+    LIBRARIES_TO_LINK ${libnetwork}
+  )
+endif()
+
+build_lib_example(
+  NAME empirical-random-variable-example
+  SOURCE_FILES empirical-random-variable-example.cc
+  LIBRARIES_TO_LINK ${libcore}
+                    ${libflow-monitor}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/empirical-random-variable-example.cc ns-3.36/src/core/examples/empirical-random-variable-example.cc
--- ns-3.35/src/core/examples/empirical-random-variable-example.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/empirical-random-variable-example.cc	2022-04-30 18:23:57.790733000 -0700
@@ -29,10 +29,12 @@
 #include <iostream>
 #include <map>
 
+
 /**
  * \file
- * \ingroup core-examples
- * \ingroup randomvariable
+ * \ingroup core-examples randomvariable
+ * \defgroup empirical-rng-example Core example: Empirical random variables use.
+ * 
  * Example program illustrating use of ns3::EmpiricalRandomVariable
  *
  * This example illustrates
@@ -47,8 +49,16 @@
  * random number generator
  */
 
+
 using namespace ns3;
 
+/**
+ * \ingroup empirical-rng-example
+ * 
+ * \brief Sample the random variable only once.
+ * \param mode Rng mode (Normal or Antithetic).
+ * \param erv The empirical random variable.
+ */
 void
 RunSingleSample (std::string mode, Ptr<EmpiricalRandomVariable> erv)
 {
@@ -68,6 +78,14 @@
   erv->SetInterpolate (false);
 }
 
+/**
+ * \ingroup empirical-rng-example
+ * 
+ * \brief Prints a stat line.
+ * \param value The value to print.
+ * \param count The number of times that value has been sampled.
+ * \param n The total number of random values sampled.
+ */
 void
 PrintStatsLine (const double value, const long count, const long n)
 {
@@ -79,6 +97,15 @@
             << std::endl;
 }
 
+/**
+ * \ingroup empirical-rng-example
+ * 
+ * \brief Prints the summary.
+ * \param sum The number of sampled values.
+ * \param n The total number of random values to be drawn.
+ * \param weighted The average of the sample.
+ * \param expected The expected average of the sample.
+ */
 void
 PrintSummary (long sum, long n, double weighted, double expected)
 {
@@ -100,6 +127,14 @@
             << std::endl;
 }
 
+/**
+ * \ingroup empirical-rng-example
+ * 
+ * \brief Sample the random variable.
+ * \param mode Rng mode (Normal or Antithetic).
+ * \param erv The empirical random variable.
+ * \param n Number of samples to draw.
+ */
 void
 RunBothModes (std::string mode, Ptr<EmpiricalRandomVariable> erv, long n)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/fatal-example.cc ns-3.36/src/core/examples/fatal-example.cc
--- ns-3.35/src/core/examples/fatal-example.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/fatal-example.cc	2022-04-30 18:23:57.790733000 -0700
@@ -26,13 +26,19 @@
 
 /**
  * \file
+ * \defgroup fatal-example Core example: NS_FATAL error handlers
  * \ingroup core-examples
- * \ingroup ptr
+ * \ingroup fatal
+ * 
  * Example program illustrating use of the NS_FATAL error handlers.
  */
 
 using namespace ns3;
 
+/**
+ * \ingroup fatal-example
+ * \brief Triggers a fatal error without message, deferring termination.
+ */
 void
 FatalNoMsg (void)
 {
@@ -41,6 +47,10 @@
   NS_FATAL_ERROR_NO_MSG_CONT ();
 }
 
+/**
+ * \ingroup fatal-example
+ * \brief Triggers a fatal error with an error message, deferring termination.
+ */
 void
 FatalCont (void)
 {
@@ -49,6 +59,10 @@
   NS_FATAL_ERROR_CONT ("fatal error, but continuing");
 }
 
+/**
+ * \ingroup fatal-example
+ * \brief Triggers a fatal error with message, and terminating.
+ */
 void
 Fatal (void)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/hash-example.cc ns-3.36/src/core/examples/hash-example.cc
--- ns-3.35/src/core/examples/hash-example.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/hash-example.cc	2022-04-30 18:23:57.790733000 -0700
@@ -40,14 +40,12 @@
  *  Example Output:
  *  \verbatim
 
-./waf --run="hasher-example --time \
+./ns3 run="hasher-example --time \
   --dict=/usr/share/dict/web2 \
   --dict=/usr/share/dict/web2a \
   --dict=/usr/share/dict/propernames \
   --dict=/usr/share/dict/connectives"
 
-Waf: Entering directory `build'
-Waf: Leaving directory `build'
 'build' finished successfully (3.028s)
 
 Hasher
@@ -111,7 +109,7 @@
 /**
  * \ingroup hash
  *  Namespace for hasher-example.
-*/
+ */
 namespace Example {
 
 /**
@@ -386,7 +384,7 @@
   /**
    * Time and report the execution of one hash across the entire Dictionary.
    *
-   * \param [in] hindex Index of the hash Collider to use.
+   * \param [in] collider The hash Collider to use.
    */
   void TimeOne (const Collider & collider)
   {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/length-example.cc ns-3.36/src/core/examples/length-example.cc
--- ns-3.35/src/core/examples/length-example.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/length-example.cc	2022-04-30 18:23:57.790733000 -0700
@@ -31,15 +31,19 @@
  */
 
 using namespace ns3;
-using Unit = Length::Unit;
 
+/**
+ * \ingroup core-examples
+ * \ingroup length
+ * \brief Demonstrates the use of ns3::Length constructors.
+ */
 void Constructors ()
 {
     double input = 5;
-    Length::Quantity quantity (input, Unit::Meter);
+    Length::Quantity quantity (input, Length::Unit::Meter);
 
     std::cout << "\nConstructors:"
-              << "\nLength (" << input << ", Unit::Meter) = " << Length (input, Unit::Meter)
+              << "\nLength (" << input << ", Unit::Meter) = " << Length (input, Length::Unit::Meter)
               << "\nLength (" << input << ", \"m\") = " << Length (input, "m")
               << "\nLength (" << input << ", \"meter\") = " << Length (input, "meter")
               << "\nLength (Quantity(" << input << ", Unit::Meter)) = " << Length (quantity)
@@ -52,20 +56,30 @@
               << std::endl;
 }
 
+/**
+ * \ingroup core-examples
+ * \ingroup length
+ * \brief Demonstrates the use of ns3::Length conversions.
+ */
 void Conversions ()
 {
   //construct length using value and unit
-  Length moonDistance (3.84402e8, Unit::Meter);
+  Length moonDistance (3.84402e8, Length::Unit::Meter);
 
   //Demonstrate conversion to various units
   std::cout << "\nConversions: "
             << "\nDistance to moon = " << moonDistance
-            << "\nIn Feet: " << moonDistance.As (Unit::Foot)
-            << "\nIn Miles: " << moonDistance.As (Unit::Mile)
-            << "\nIn Kilometers: " << moonDistance.As (Unit::Kilometer)
+            << "\nIn Feet: " << moonDistance.As (Length::Unit::Foot)
+            << "\nIn Miles: " << moonDistance.As (Length::Unit::Mile)
+            << "\nIn Kilometers: " << moonDistance.As (Length::Unit::Kilometer)
             << std::endl;
 }
 
+/**
+ * \ingroup core-examples
+ * \ingroup length
+ * \brief Demonstrates the use of ns3::Length arithmetic operators.
+ */
 void ArithmeticOperators ()
 {
   double scale = 10;
@@ -89,6 +103,11 @@
 
 }
 
+/**
+ * \ingroup core-examples
+ * \ingroup length
+ * \brief Demonstrates the use of ns3::Length equality operators.
+ */
 void EqualityOperators ()
 {
   Length oneMeter = Meters (1);
@@ -119,6 +138,11 @@
             << std::endl;
 }
 
+/**
+ * \ingroup core-examples
+ * \ingroup length
+ * \brief Demonstrates the use of ns3::Length multiplications and divisions.
+ */
 void DivAndMod ()
 {
   //construct length using helper function
@@ -128,16 +152,16 @@
 
   int64_t count = Div (totalLen, pieceLen, &remainder);
 
-  std::cout << "\nHow many times can a " << totalLen.As (Unit::Foot) << " length "
-            << "be split into " << pieceLen.As (Unit::Foot) << " sized pieces? "
+  std::cout << "\nHow many times can a " << totalLen.As (Length::Unit::Foot) << " length "
+            << "be split into " << pieceLen.As (Length::Unit::Foot) << " sized pieces? "
             << count
-            << "\nremainder: " << remainder.As (Unit::Foot)
+            << "\nremainder: " << remainder.As (Length::Unit::Foot)
             << std::endl;
 
   std::cout << "\nHow much remains after splitting a "
-            << totalLen.As (Unit::Foot) << " length into "
-            << pieceLen.As (Unit::Foot) << " sized pieces? "
-            << Mod (totalLen, pieceLen).As (Unit::Foot)
+            << totalLen.As (Length::Unit::Foot) << " length into "
+            << pieceLen.As (Length::Unit::Foot) << " sized pieces? "
+            << Mod (totalLen, pieceLen).As (Length::Unit::Foot)
             << std::endl;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/sample-log-time-format.cc ns-3.36/src/core/examples/sample-log-time-format.cc
--- ns-3.35/src/core/examples/sample-log-time-format.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/sample-log-time-format.cc	2022-04-30 18:23:57.790733000 -0700
@@ -28,7 +28,7 @@
  * occur at future times.  When run with no arguments, it prints out
  * something like this:
  * \code
- * $ ./waf --run sample-log-time-format
+ * $ ./ns3 run sample-log-time-format
  * RandomVariableStream:RandomVariableStream(0x184e3a0)
  * RandomVariableStream:UniformRandomVariable(0x184e3a0)
  * RandomVariableStream:SetStream(0x184e3a0, -1)
@@ -60,7 +60,7 @@
  * replacement function for printing time.  This can be demonstrated
  * by setting the 'replace-time-printer' parameter to true:
  * \code
- * ./waf --run 'sample-log-time-format --replaceTimePrinter=1'
+ * ./ns3 run 'sample-log-time-format --replaceTimePrinter=1'
  * RandomVariableStream:RandomVariableStream(0x15fb080)
  * RandomVariableStream:UniformRandomVariable(0x15fb080)
  * RandomVariableStream:SetStream(0x15fb080, -1)
